%define ALD_Ver		1.2.4
%define X11_Version	7.7
%define X11_Release	4
%define USE_ProtoBinDir 1


Name:         xf86-video-intel
Version:      2.99.917
Release:      0

License:      The Xorg Project
Summary:      Xorg video driver intel
Group:        Development/Libraries

Source: %{name}-%{version}.tar.xz
Source1: CROSS-X11.sh

%define DestDir		/X11/%{X11_Version}-%{X11_Release}
# -----------------------------------------------------
%if %{_target_cpu} == %{_build_cpu}
%define _CROSS 0
%else
# rpm --target=x86_64 -ba xxxxx.spec
%define _CROSS 1
%endif

%define TO_ARCH %{_target_cpu}

%if %{_target_cpu} == "armv6l"
%define ARM_ARCH armv6zk
%define ARM_FPU  -mfpu=vfp -mfloat-abi=hard
%define TO_ARCH %{ARM_ARCH}
%endif

%if %{_target_cpu} == "armv7l"
%define ARM_ARCH armv7-a
%define ARM_FPU  -mfpu=vfpv3-d16 -mfloat-abi=hard
%define TO_ARCH %{ARM_ARCH}
%endif

%define BUILD_TAR 1
#------------------ CROSS DIR --------------------
%define _prefix /usr/X11R%{X11_Version}
%define _libdir	%{_prefix}/%{_lib}
%define protoPrefix /var/tmp/X11R%{X11_Version}-%{X11_Release}/%{TO_ARCH}
%define protoBinDir %{protoPrefix}/bin
%define protoDir %{protoPrefix}%{_prefix}

%define _defaultdocdir	%{_prefix}/share/doc
%define _mandir %{_prefix}/man

%if %{_CROSS}

%if %{_os} == "mingw"
ERROR: target=%{_os}
%else  #win32 || win64
%define target %{_arch}-%{_os}%{_gnu}
%endif

%define crossdir	/cross
%if %{_arch} == "arm"
ERROR: target=%{_os}
%else
%define csysdir		%{crossdir}/%{_target_cpu}
%endif
%define csysbindir	%{csysdir}/bin
%define target_  %{target}-
%define hosttarget --host=%{target}

%define cross_prefix	%{csysdir}%{_prefix}
%define cross_bindir	%{csysdir}%{_bindir}
%define cross_sbindir	%{csysdir}%{_sbindir}
%define cross_libdir	%{csysdir}%{_libdir}
%define cross_includedir %{csysdir}%{_includedir}
%define cross_datadir	%{csysdir}%{_datadir}
%define cross_infodir	%{csysdir}%{_infodir}
%define cross_mandir	%{csysdir}%{_mandir}
%define cross_defaultdocdir %{csysdir}%{_defaultdocdir}
%define cross_docdir	%{cross_defaultdocdir}/%{name}

%define CrossDestDir	/Cross

%define _srcrpmdir	%{_topdir}/SRPMS/tmp

%else  #_CROSS

%define csysdir		%{nil}
%define csysbindir	%{_prefix}/bin
%define CrossDestDir	%{nil}
%define _srcrpmdir	%{_topdir}/SRPMS/%{ALD_Ver}

%define target %{_build}
%define target_  %{nil}
%define hosttarget %{nil}

%endif # !_CROSS

%if %{USE_ProtoBinDir}
%define __os_install_post %{nil}
%endif

%define docdir		%{_defaultdocdir}/%{name}

# ------------------- description ------------------------------------
%description
The xf86-video-intel module is an open-source 2D graphics driver for
the X Window System as implemented by X.org. It supports a variety of
Intel graphics chipsets including:

	i810/i810e/i810-dc100,i815,
	i830M,845G,852GM,855GM,865G,
	915G/GM,945G/GM/GME,946GZ
	G/GM/GME/Q965,
	G/Q33,G/Q35,G41,G/Q43,G/GM/Q45
	PineView-M (Atom N400 series)
	PineView-D (Atom D400/D500 series)
	Intel(R) HD Graphics: 2000-6000,
	Intel(R) Iris(TM) Graphics: 5100/6100, and
	Intel(R) Iris(TM) Pro Graphics: 5200/6200/P6300.
#-------------------------------
%package virtual-output
Summary:      intel virtual output
Group:        Development/Libraries
%description virtual-output
Utility for connecting the Integrated Intel GPU to discrete outputs

# ------------------- setup ------------------------------------------
%Prep
%setup -q -n %{name}-%{version}

sed -i s:"am__append_1 = test":"am__append_1 =": Makefile.in

# ------------------- Build ------------------------------------------
%Build
CPATH=
%if %{_CROSS}
CPATH="%{csysbindir}:"
export GCC_NoHostPath=d
%endif
%if %{USE_ProtoBinDir}
CPATH="$CPATH%{protoBinDir}:"
%endif
export PATH=$CPATH$PATH:/opt/perl/bin

%if %{_arch} == "i386"
OPTFLAGS="-O2 -march=i486 -ffast-math -mpreferred-stack-boundary=3 -falign-functions=1 -falign-jumps=1 -falign-loops=1 -fomit-frame-pointer"
%endif
%if %{_arch} == "x86_64"
OPTFLAGS="-O2 -fPIC -fno-asynchronous-unwind-tables"
%endif
%if %{_arch} == "arm"
%if %{_target_cpu} == "armv7l"
OPTFLAGS="-O2 -fPIC -march=%{ARM_ARCH} %{ARM_FPU} -munaligned-access"
%else
OPTFLAGS="-O2 -march=%{ARM_ARCH} %{ARM_FPU} -munaligned-access"
%endif
%endif

%if %{USE_ProtoBinDir}
PKG_CONFIG_PATH="%{protoPrefix}%{_libdir}/pkgconfig:%{protoPrefix}/usr/%{_lib}/pkgconfig:%{protoPrefix}/usr/share/pkgconfig"
export PKG_CONFIG_PATH 
LDFLAGS="-L%{protoPrefix}%{_libdir}"
%endif

prefX11="--build=%{_build} %{hosttarget} \
	--prefix=%{_prefix} \
	--libdir=%{_libdir} \
	--libexecdir=%{_libdir} \
	--datarootdir=%{_libdir} \
	--mandir=%{_mandir} \
	--localstatedir=/var \
	--sysconfdir=/etc"

moduledir="%{_libdir}/modules"

CXXFLAGS="$OPTFLAGS -D_GNU_SOURCE"
CFLAGS="$OPTFLAGS -ffunction-sections -fdata-sections -D_GNU_SOURCE -std=gnu99"
LDFLAGS="$LDFLAGS -Wl,--gc-sections"

export CFLAGS CXXFLAGS LDFLAGS

CPPFLAGS="-I%{protoPrefix}%{_includedir}" ./configure $prefX11 \
	--docdir=%{docdir} \
	--disable-libtool-lock \
	--with-xorg-module-dir=$moduledir \
	--disable-debug \
	&>Fconfigure_log.txt

make V=1 &>Fmake_log.txt

# ------------------- Install ----------------------------------------
%Install
CPATH=
%if %{_CROSS}
CPATH="%{csysbindir}:"
export GCC_NoHostPath=d
%endif
%if %{USE_ProtoBinDir}
CPATH="$CPATH%{protoBinDir}:"
RPM_TMP_ROOT=$RPM_BUILD_ROOT/tmp
%else   # USE_ProtoBinDir
RPM_TMP_ROOT=$RPM_BUILD_ROOT
%endif
export PATH=$CPATH$PATH:/opt/perl/bin

rm -rf $RPM_BUILD_ROOT
mkdir -p $RPM_TMP_ROOT%{docdir}

make DESTDIR=$RPM_TMP_ROOT install &>FInstall_log.txt
rm -f $RPM_TMP_ROOT%{_libdir}/modules/drivers/*.la

cp AUTHORS COPYING README $RPM_TMP_ROOT%{docdir}/

%if %{USE_ProtoBinDir}
TARGET_PRFIX=%{_prefix}
RPM_TMP_ROOT=$RPM_BUILD_ROOT/tmp
TARGET_INSTDIR=$RPM_BUILD_ROOT%{csysdir}%{_prefix}
TARGET_NAME=%{target_}
TARGET_LIB=%{_lib}
export TARGET_PRFIX RPM_TMP_ROOT TARGET_INSTDIR TARGET_NAME TARGET_LIB

TARGET_ProtoDir=%{protoDir}
TARGET_CrossDir=%{csysdir}%{_prefix}
MKCROSSDIR=0
export TARGET_ProtoDir TARGET_CrossDir MKCROSSDIR
%SOURCE1 $sf
%endif  # !USE_ProtoBinDir

%if !%{_CROSS}
if test -f /opt/aldccp/bin/packages_idx; then
  /opt/aldccp/bin/packages_idx -p %{name} -v %{version} -r %{DestDir} $RPM_BUILD_ROOT
fi
%endif

# ------------------- Clean ------------------------------------------
%Clean
DE=%{version}-%{release}.%{TO_ARCH}.rpm
DD=%{_rpmdir}/%{TO_ARCH}/%{ALD_Ver}%{DestDir}
DEC=%{version}-%{release}.%{_build_cpu}.rpm
DDC=%{_rpmdir}/%{_build_cpu}/%{ALD_Ver}%{CrossDestDir}/%{TO_ARCH}%{DestDir}

pushd %{_rpmdir}/%{_target_cpu}
  SE=%{version}-%{release}.%{_target_cpu}.rpm
  mkdir -p $DD
  mv %{name}-$SE $DD/%{name}-$DE
%if %{_arch} == "x86_64"
  mv %{name}-virtual-output-$SE $DD/%{name}-virtual-output-$DE
%endif
popd
 

# --------------- build *.tgz ------------------------
%if %{BUILD_TAR}
pushd $RPM_BUILD_ROOT
  TMP_TO=$DD/tar
  mkdir -p $TMP_TO
  tmp=%{name}-%{version}-%{release}.%{TO_ARCH}
  mkdir -p $tmp
  cp -r usr $tmp/
  tar -cjf $tmp.tar.bz2 $tmp
  mv $tmp.tar.bz2 $TMP_TO
  rm -r $tmp
popd
%endif  #BUILD_TAR

# ------------------- Files ------------------------------------------

%files
%{_libdir}/xf86-video-intel-backlight-helper
%{_libdir}/modules/drivers/intel_drv.so
%{_libdir}/polkit-1/actions/org.x.xf86-video-intel.backlight-helper.policy
%{_mandir}/man4/intel.4.gz
%{docdir}

%if %{_arch} == "x86_64"
%files virtual-output
%{_bindir}/intel-virtual-output
%{_mandir}/man4/intel-virtual-output.4.gz
%endif
